"""
File: algorithms.py

Graph processing algorithms
"""

from stack import LinkedStack
from queue import LinkedQueue

def topoSort(g, startLabel = None):  
    stack = LinkedStack()
    g.clearVertexMarks()
    for v in g.vertices():
        if not v.isMarked():
            dfs(g, v, stack)
    lyst = []
    return stack

def bfs(g, v):
    queue = LinkedQueue()
    g.clearVertexMarks()
    v.setMark()
    print "enqueue:",v
    queue.enqueue(v)
    while not queue.isEmpty():
        v = queue.dequeue()
        for w in g.neighboringVertices(v.getLabel()):
            if not w.isMarked():
                w.setMark()
                w.setPrevious(v.getLabel())
                queue.enqueue(w)
                print "enqueue:",w 

def dfs(g, v, stack):
    v.setMark()
    print "setMark of vertex:",v
    for w in g.neighboringVertices(v.getLabel()):
        if not w.isMarked():
            dfs(g, w, stack)
    stack.push(v)
    print "pushing vertex onto stack:",v 

def shortestPaths(g, startLabel):
    # Exercise
    return ["Under development"]

def spanTree(g, startLabel):
    # Exercise
    return ["Under development"]


